import java.math.*;
import java.util.*;

/**
 * Ten program wykorzystuje wielkie liczby do obliczenia szans wygrania na loterii.
 * @version 1.20 2004-02-10
 * @author Cay Horstmann
 */
public class BigIntegerTest
{
   public static void main(String[] args)
   {
      Scanner in = new Scanner(System.in);

      System.out.print("Ile liczb ma być wylosowanych? ");
      int k = in.nextInt();

      System.out.print("Jaka jest górna granica przedziału losowanych liczb? ");
      BigInteger n = in.nextBigInteger();

      /*
       * Obliczanie współczynnika dwumianowego n*(n–1)*(n–2)*…*(n–k+1)/(1*2*3*…*k)
       */

      BigInteger lotteryOdds = BigInteger.ONE;

      for (int i = 1; i <= k; i++)
         lotteryOdds = lotteryOdds
             .multiply(n.subtract(BigInteger.valueOf(i - 1)))
         .divide(BigInteger.valueOf(i));

      System.out.printf("Twoje szanse to 1 do %s. Powodzenia!%n", lotteryOdds);
   }
}